package Pi3;

use 5.006;
use strict;
use warnings;
use Carp;

require Exporter;
require DynaLoader;
use AutoLoader;

our @ISA = qw(Exporter DynaLoader);

# Items to export into callers namespace by default. Note: do not export
# names by default without a very good reason. Use EXPORT_OK instead.
# Do not simply export all your public functions/methods/constants.

# This allows declaration	use Pi3 ':all';
# If you do not need this, moving things directly into @EXPORT or @EXPORT_OK
# will save memory.
our %EXPORT_TAGS = ( 'all' => [ qw(
	GETDB_CONNECTION
	GETDB_HOST
	GETDB_REQUEST
	GETDB_RESPONSE
	HTTPDEFS_H_
	HTTPS_DEFAULT_PORT
	HTTP_CR
	HTTP_DEFAULT_PORT
	HTTP_DIRSEPERATOR
	HTTP_LF
	INT_CONTINUE
	INT_REDIRECT
	MD_CONNECT
	MD_DELETE
	MD_GET
	MD_HEAD
	MD_LAST
	MD_OPTIONS
	MD_POST
	MD_PUT
	MD_TRACE
	MD_UNKNOWN
	PH_CHECKACCESS
	PH_CHECKAUTH
	PH_CHECKPATH
	PH_CHECKTYPE
	PH_DESTROY
	PH_HANDLE
	PH_HEADERS
	PH_HOSTMAP
	PH_INIT
	PH_INVALID
	PH_LOG
	PH_MAPPING
	PH_NUMBER
	PI3PAPI_H_
	PIAPI_ABORT
	PIAPI_COMPLETED
	PIAPI_CONTINUE
	PIAPI_DEADLOCK
	PIAPI_EACCES
	PIAPI_EEXIST
	PIAPI_EINIT
	PIAPI_EINVAL
	PIAPI_ERROR
	PIAPI_EXHAUSTED
	PIAPI_FALSE
	PIAPI_INTERNALERROR
	PIAPI_NOTSUPPORTED
	PIAPI_TIMEOUT
	PIAPI_TRUE
	PIAPI_WARNING
	PIAPI_WOULDBLOCK
	PIDBFLAG_FASTKEY
	PIDBFLAG_NOCALLBACK
	PIDBFLAG_NONE
	PIDBFLAG_PROPAGATEUP
	PIDBTYPE_BUILTINSIZE
	PIDBTYPE_INVALID
	PIDBTYPE_LAST
	PIDBTYPE_OPAQUE
	PIDBTYPE_RFC822
	PIDBTYPE_STRING
	PIDBTYPE_TREE
	PIDBTYPE_USER
	PIDEFS_H_
	PIIOBUF_CHUNKED
	PIIOBUF_NOBUFFER
	PIIOBUF_NONE
	PITHREAD_FLAGS_SUSPENDED
	PITHREAD_PRIORITY_HIGH
	PITHREAD_PRIORITY_HIGHEST
	PITHREAD_PRIORITY_INVALID
	PITHREAD_PRIORITY_LOW
	PITHREAD_PRIORITY_LOWEST
	PITHREAD_PRIORITY_MED
	PITHREAD_PRIORITY_SIZE
	PR_HTTP09
	PR_HTTP10
	PR_HTTP11
	PR_UNKNOWN
	ST_ACCEPTED
	ST_BADGATEWAY
	ST_BADREQUEST
	ST_CONFLICT
	ST_CONTINUE
	ST_CREATED
	ST_EXPECTATIONFAILED
	ST_FORBIDDEN
	ST_FOUND
	ST_GATEWAYTIMEOUT
	ST_GONE
	ST_INTERNALERROR
	ST_LENGTHREQUIRED
	ST_METHODNOTALLOWED
	ST_MULTIPLECHOICES
	ST_NOCONTENT
	ST_NONAUTHORITATIVEINFO
	ST_NOTACCEPTABLE
	ST_NOTFOUND
	ST_NOTIMPLEMENTED
	ST_NOTMODIFIED
	ST_OK
	ST_PARTIALCONTENT
	ST_PAYMENTREQUIRED
	ST_PERMANENTREDIRECT
	ST_PRECONDITIONFAILED
	ST_PROXYAUTHREQUIRED
	ST_RANGENOTSATISFIABLE
	ST_REQUESTENTITYTOOLARGE
	ST_REQUESTTIMEOUT
	ST_REQUESTURITOOLONG
	ST_RESETCONTENT
	ST_SEEOTHER
	ST_SERVICEUNAVAILABLE
	ST_SWITCHINGPROTOCOLS
	ST_TEMPORARYREDIRECT
	ST_UNAUTHORIZED
	ST_UNSUPPORTEDMEDIATYPE
	ST_UNSUPPORTEDVERSION
	ST_UNUSED
	ST_USEPROXY
	HTTPCore_cleanupClient
	HTTPCore_cleanupServer
	HTTPCore_debugEnabled
	HTTPCore_dispatch
	HTTPCore_executePhase
	HTTPCore_getCachedFile
	HTTPCore_getMIMETypeFromExtension
	HTTPCore_getServerStamp
	HTTPCore_initClient
	HTTPCore_initServer
	HTTPCore_loadMIMEFile
	HTTPCore_logDebug
	HTTPCore_logError
	HTTPCore_readHeaders
	HTTPCore_relativeToAbsolutePath
	HTTPCore_releaseCachedFile
	HTTPCore_sendEntityHeaders
	HTTPCore_sendGeneralHeaders
	HTTPUtil_contractPath
	HTTPUtil_doHTTPError
	HTTPUtil_doHTTPRequest
	HTTPUtil_getHostName
	HTTPUtil_getHostPort
	HTTPUtil_phaseNameToNumber
	HTTPUtil_phaseNumberToName
	HTTPUtil_protocolNumberToName
	HTTPUtil_rFC822Time
	HTTPUtil_rcNameToNumber
	HTTPUtil_rcNumberToName
	HTTPUtil_readTime
	HTTPUtil_recvFile
	HTTPUtil_recvMultipartMsg
	HTTPUtil_regexMatch
	HTTPUtil_regexMatchPi3String
	HTTPUtil_sendFile
	HTTPUtil_urlDecode
	HTTPUtil_urlEncode
	PIClass_getLibrary
	PIClass_load
	PIClass_lookup
	PIClass_lookupOrLoad
	PIConfigString_getString
	PIConfig_findConfiguration
	PIConfig_loadConfigurationFile
	PIConfig_lookupTree
	PIConfig_lookupValue
	PIDBEx_new
	PIDBIterator_atValidElement
	PIDBIterator_current
	PIDBIterator_delete
	PIDBIterator_next
	PIDBIterator_removeCurrent
	PIDB_add
	PIDB_delete
	PIDB_getFastKey
	PIDB_getIterator
	PIDB_getParent
	PIDB_getRoot
	PIDB_lookup
	PIDB_new
	PIDB_pidbflagsNameToNumber
	PIDB_pidbtypeNameToNumber
	PIDB_replace
	PIDLL_delete
	PIDLL_getAddress
	PIDLL_getErrorDescription
	PIDLL_getSystemHandle
	PIDLL_isLoaded
	PIDLL_new
	PIFInfo_delete
	PIFInfo_exists
	PIFInfo_getAlternateName
	PIFInfo_getExtension
	PIFInfo_getFirstFileInDirectory
	PIFInfo_getLastModified
	PIFInfo_getName
	PIFInfo_getNextFileInDirectory
	PIFInfo_getPath
	PIFInfo_getPathRoot
	PIFInfo_getSize
	PIFInfo_isDirectory
	PIFInfo_isExecutable
	PIFInfo_isLink
	PIFInfo_isReadable
	PIFInfo_isRegular
	PIFInfo_isWritable
	PIFInfo_new
	PIFMap_delete
	PIFMap_lock
	PIFMap_new
	PIFMap_unlock
	PIFile_close
	PIFile_open
	PIFile_read
	PIFile_unlink
	PIFile_write
	PIFile_writeAtomic
	PIHTTP_allocMem
	PIHTTP_delete
	PIHTTP_getDB
	PIHTTP_isChild
	PIHTTP_new
	PIHTTP_newChild
	PIIOBuffer_advanceBufferPointer
	PIIOBuffer_delete
	PIIOBuffer_flush
	PIIOBuffer_getBufferLen
	PIIOBuffer_getBytesSent
	PIIOBuffer_getLine
	PIIOBuffer_getOutputBuffer
	PIIOBuffer_getUserData
	PIIOBuffer_new
	PIIOBuffer_pollBeforeRead
	PIIOBuffer_read
	PIIOBuffer_readToBuffer
	PIIOBuffer_resetBytesSent
	PIIOBuffer_setUserData
	PIIOBuffer_write
	PIIOBuffer_writeLn
	PIIO_in
	PIIO_out
	PILibrary_load
	PILibrary_lookup
	PILibrary_lookupOrLoad
	PILog_addMessage
	PILog_newSink
	PILog_writeDiagnostics
	PILogic_execute
	PIObject_copy
	PIObject_delete
	PIObject_getClass
	PIObject_getConfigurationDB
	PIObject_getDB
	PIObject_getName
	PIObject_getUserData
	PIObject_load
	PIObject_loadEx
	PIObject_loadFromLine
	PIObject_new
	PIObject_readParameters
	PIObject_setConfigurationDB
	PIObject_setDB
	PIObject_setUserData
	PIPlatform_advisaryLockFd
	PIPlatform_advisaryUnlockFd
	PIPlatform_afterUnsafeBlock
	PIPlatform_allocLocalMutex
	PIPlatform_allocLocalSemaphore
	PIPlatform_beforeUnsafeBlock
	PIPlatform_catchExceptions
	PIPlatform_enter
	PIPlatform_getCurrentDirectory
	PIPlatform_getDescription
	PIPlatform_getDirectorySeparator
	PIPlatform_getLastError
	PIPlatform_getProcess
	PIPlatform_getProcessId
	PIPlatform_getUniqueId
	PIPlatform_pollFD
	PIPlatform_pollNetFD
	PIPlatform_pollPipeFD
	PIPlatform_setLastError
	PIPlatform_sleep
	PIPlatform_waitForProcess
	PIProgram_dbgDump
	PIProgram_enter
	PISync_delete
	PISync_lock
	PISync_tryLock
	PISync_unlock
	PIThread_begin
	PIThread_dbgDump
	PIThread_delete
	PIThread_destroyThreadKey
	PIThread_getCurrent
	PIThread_getData
	PIThread_getMain
	PIThread_getPriority
	PIThread_getSystemHandle
	PIThread_initThreadKey
	PIThread_new
	PIThread_resume
	PIThread_setData
	PIThread_setPriority
	PIThread_suspend
	PIThread_terminate
	PIThread_userYield
	PIThread_waitForThread
	PIThread_yield
	PITimer_delete
	PITimer_elapsed
	PITimer_new
	PITimer_reset
	PIUserType_getValue
	PIUtil_free
	PIUtil_malloc
	PIUtil_strdup
	PIUtil_stricmp
	PIUtil_strncmpi
	Pi3Expression_delete
	Pi3Expression_new
	Pi3Expression_write
	Pi3String_delete
	Pi3String_getLength
	Pi3String_getPtr
	Pi3String_new
	Pi3String_newEx
) ] );

our @EXPORT_OK = ( @{ $EXPORT_TAGS{'all'} } );

our @EXPORT = qw(
	GETDB_CONNECTION
	GETDB_HOST
	GETDB_REQUEST
	GETDB_RESPONSE
	HTTPDEFS_H_
	HTTPS_DEFAULT_PORT
	HTTP_CR
	HTTP_DEFAULT_PORT
	HTTP_DIRSEPERATOR
	HTTP_LF
	INT_CONTINUE
	INT_REDIRECT
	MD_CONNECT
	MD_DELETE
	MD_GET
	MD_HEAD
	MD_LAST
	MD_OPTIONS
	MD_POST
	MD_PUT
	MD_TRACE
	MD_UNKNOWN
	PH_CHECKACCESS
	PH_CHECKAUTH
	PH_CHECKPATH
	PH_CHECKTYPE
	PH_DESTROY
	PH_HANDLE
	PH_HEADERS
	PH_HOSTMAP
	PH_INIT
	PH_INVALID
	PH_LOG
	PH_MAPPING
	PH_NUMBER
	PI3PAPI_H_
	PIAPI_ABORT
	PIAPI_COMPLETED
	PIAPI_CONTINUE
	PIAPI_DEADLOCK
	PIAPI_EACCES
	PIAPI_EEXIST
	PIAPI_EINIT
	PIAPI_EINVAL
	PIAPI_ERROR
	PIAPI_EXHAUSTED
	PIAPI_FALSE
	PIAPI_INTERNALERROR
	PIAPI_NOTSUPPORTED
	PIAPI_TIMEOUT
	PIAPI_TRUE
	PIAPI_WARNING
	PIAPI_WOULDBLOCK
	PIDBFLAG_FASTKEY
	PIDBFLAG_NOCALLBACK
	PIDBFLAG_NONE
	PIDBFLAG_PROPAGATEUP
	PIDBTYPE_BUILTINSIZE
	PIDBTYPE_INVALID
	PIDBTYPE_LAST
	PIDBTYPE_OPAQUE
	PIDBTYPE_RFC822
	PIDBTYPE_STRING
	PIDBTYPE_TREE
	PIDBTYPE_USER
	PIDEFS_H_
	PIIOBUF_CHUNKED
	PIIOBUF_NOBUFFER
	PIIOBUF_NONE
	PITHREAD_FLAGS_SUSPENDED
	PITHREAD_PRIORITY_HIGH
	PITHREAD_PRIORITY_HIGHEST
	PITHREAD_PRIORITY_INVALID
	PITHREAD_PRIORITY_LOW
	PITHREAD_PRIORITY_LOWEST
	PITHREAD_PRIORITY_MED
	PITHREAD_PRIORITY_SIZE
	PR_HTTP09
	PR_HTTP10
	PR_HTTP11
	PR_UNKNOWN
	ST_ACCEPTED
	ST_BADGATEWAY
	ST_BADREQUEST
	ST_CONFLICT
	ST_CONTINUE
	ST_CREATED
	ST_EXPECTATIONFAILED
	ST_FORBIDDEN
	ST_FOUND
	ST_GATEWAYTIMEOUT
	ST_GONE
	ST_INTERNALERROR
	ST_LENGTHREQUIRED
	ST_METHODNOTALLOWED
	ST_MULTIPLECHOICES
	ST_NOCONTENT
	ST_NONAUTHORITATIVEINFO
	ST_NOTACCEPTABLE
	ST_NOTFOUND
	ST_NOTIMPLEMENTED
	ST_NOTMODIFIED
	ST_OK
	ST_PARTIALCONTENT
	ST_PAYMENTREQUIRED
	ST_PERMANENTREDIRECT
	ST_PRECONDITIONFAILED
	ST_PROXYAUTHREQUIRED
	ST_RANGENOTSATISFIABLE
	ST_REQUESTENTITYTOOLARGE
	ST_REQUESTTIMEOUT
	ST_REQUESTURITOOLONG
	ST_RESETCONTENT
	ST_SEEOTHER
	ST_SERVICEUNAVAILABLE
	ST_SWITCHINGPROTOCOLS
	ST_TEMPORARYREDIRECT
	ST_UNAUTHORIZED
	ST_UNSUPPORTEDMEDIATYPE
	ST_UNSUPPORTEDVERSION
	ST_UNUSED
	ST_USEPROXY
);
our $VERSION = '0.01';

sub AUTOLOAD {
    # This AUTOLOAD is used to 'autoload' constants from the constant()
    # XS function.  If a constant is not found then control is passed
    # to the AUTOLOAD in AutoLoader.

    my $constname;
    our $AUTOLOAD;
    ($constname = $AUTOLOAD) =~ s/.*:://;
    croak "& not defined" if $constname eq 'constant';
    my $val = constant($constname, @_ ? $_[0] : 0);
    if ($! != 0) {
	if ($! =~ /Invalid/ || $!{EINVAL}) {
	    $AutoLoader::AUTOLOAD = $AUTOLOAD;
	    goto &AutoLoader::AUTOLOAD;
	}
	else {
	    croak "Your vendor has not defined Pi3 macro $constname";
	}
    }
    {
	no strict 'refs';
	*$AUTOLOAD = sub { $val };
    }
    goto &$AUTOLOAD;
}

bootstrap Pi3 $VERSION;

# Preloaded methods go here.

# Autoload methods go after =cut, and are processed by the autosplit program.

1;
__END__
# Below is stub documentation for your module. You better edit it!

=head1 NAME

Pi3 - Perl extension for blah blah blah

=head1 SYNOPSIS

  use Pi3;
  blah blah blah

=head1 DESCRIPTION

Stub documentation for Pi3, created by h2xs. It looks like the
author of the extension was negligent enough to leave the stub
unedited.

Blah blah blah.

=head2 EXPORT

None by default.

=head2 Exportable constants

  GETDB_CONNECTION
  GETDB_HOST
  GETDB_REQUEST
  GETDB_RESPONSE
  HTTPDEFS_H_
  HTTPS_DEFAULT_PORT
  HTTP_CR
  HTTP_DEFAULT_PORT
  HTTP_DIRSEPERATOR
  HTTP_LF
  INT_CONTINUE
  INT_REDIRECT
  MD_CONNECT
  MD_DELETE
  MD_GET
  MD_HEAD
  MD_LAST
  MD_OPTIONS
  MD_POST
  MD_PUT
  MD_TRACE
  MD_UNKNOWN
  PH_CHECKACCESS
  PH_CHECKAUTH
  PH_CHECKPATH
  PH_CHECKTYPE
  PH_DESTROY
  PH_HANDLE
  PH_HEADERS
  PH_HOSTMAP
  PH_INIT
  PH_INVALID
  PH_LOG
  PH_MAPPING
  PH_NUMBER
  PI3PAPI_H_
  PIAPI_ABORT
  PIAPI_COMPLETED
  PIAPI_CONTINUE
  PIAPI_DEADLOCK
  PIAPI_EACCES
  PIAPI_EEXIST
  PIAPI_EINIT
  PIAPI_EINVAL
  PIAPI_ERROR
  PIAPI_EXHAUSTED
  PIAPI_FALSE
  PIAPI_INTERNALERROR
  PIAPI_NOTSUPPORTED
  PIAPI_TIMEOUT
  PIAPI_TRUE
  PIAPI_WARNING
  PIAPI_WOULDBLOCK
  PIDBFLAG_FASTKEY
  PIDBFLAG_NOCALLBACK
  PIDBFLAG_NONE
  PIDBFLAG_PROPAGATEUP
  PIDBTYPE_BUILTINSIZE
  PIDBTYPE_INVALID
  PIDBTYPE_LAST
  PIDBTYPE_OPAQUE
  PIDBTYPE_RFC822
  PIDBTYPE_STRING
  PIDBTYPE_TREE
  PIDBTYPE_USER
  PIDEFS_H_
  PIIOBUF_CHUNKED
  PIIOBUF_NOBUFFER
  PIIOBUF_NONE
  PITHREAD_FLAGS_SUSPENDED
  PITHREAD_PRIORITY_HIGH
  PITHREAD_PRIORITY_HIGHEST
  PITHREAD_PRIORITY_INVALID
  PITHREAD_PRIORITY_LOW
  PITHREAD_PRIORITY_LOWEST
  PITHREAD_PRIORITY_MED
  PITHREAD_PRIORITY_SIZE
  PR_HTTP09
  PR_HTTP10
  PR_HTTP11
  PR_UNKNOWN
  ST_ACCEPTED
  ST_BADGATEWAY
  ST_BADREQUEST
  ST_CONFLICT
  ST_CONTINUE
  ST_CREATED
  ST_EXPECTATIONFAILED
  ST_FORBIDDEN
  ST_FOUND
  ST_GATEWAYTIMEOUT
  ST_GONE
  ST_INTERNALERROR
  ST_LENGTHREQUIRED
  ST_METHODNOTALLOWED
  ST_MULTIPLECHOICES
  ST_NOCONTENT
  ST_NONAUTHORITATIVEINFO
  ST_NOTACCEPTABLE
  ST_NOTFOUND
  ST_NOTIMPLEMENTED
  ST_NOTMODIFIED
  ST_OK
  ST_PARTIALCONTENT
  ST_PAYMENTREQUIRED
  ST_PERMANENTREDIRECT
  ST_PRECONDITIONFAILED
  ST_PROXYAUTHREQUIRED
  ST_RANGENOTSATISFIABLE
  ST_REQUESTENTITYTOOLARGE
  ST_REQUESTTIMEOUT
  ST_REQUESTURITOOLONG
  ST_RESETCONTENT
  ST_SEEOTHER
  ST_SERVICEUNAVAILABLE
  ST_SWITCHINGPROTOCOLS
  ST_TEMPORARYREDIRECT
  ST_UNAUTHORIZED
  ST_UNSUPPORTEDMEDIATYPE
  ST_UNSUPPORTEDVERSION
  ST_UNUSED
  ST_USEPROXY

=head2 Exportable functions

  int HTTPCore_cleanupClient()
  int HTTPCore_cleanupServer()
  int HTTPCore_debugEnabled()
  int HTTPCore_dispatch( PIHTTP *pPIHTTP, int iStartPhase,
		int iEndPhase )
  int HTTPCore_executePhase( PIHTTP *pPIHTTP,
		PIObject *nextHandler, void *pArg)
  PIFInfo *HTTPCore_getCachedFile( char *pPath )
  char *HTTPCore_getMIMETypeFromExtension(
		char *pExtension )
  char *HTTPCore_getServerStamp()
  int HTTPCore_initClient()
  int HTTPCore_initServer( PIObject *pObject )
  int HTTPCore_loadMIMEFile( PIObject *pObject, PIDB *pMimeDB,
	char *pMimeFile )
  int HTTPCore_logDebug( int iLevel, char *pFormat, ... )
  int HTTPCore_logError( PIHTTP *pPIHTTP, char *pFormat, ... )
  int HTTPCore_readHeaders( PIIOBuffer *pB, PIDB *pDB, int iFlags )
  int HTTPCore_relativeToAbsolutePath( PIDB *pDB,
        char *pRelative, Pi3String *pResult )
  void HTTPCore_releaseCachedFile( PIFInfo *pInfo )
  int HTTPCore_sendEntityHeaders( PIHTTP *pPIHTTP, PIDB *pR )
  int HTTPCore_sendGeneralHeaders( PIHTTP *pPIHTTP )
  int HTTPUtil_contractPath( char *pPath )
  int HTTPUtil_doHTTPError( PIHTTP *pPIHTTP, int iError )
  int HTTPUtil_doHTTPRequest( PIIOBuffer *pBuffer,
    PIDB *pRequestData )
  char *HTTPUtil_getHostName( PIHTTP *pPIHTTP )
  char *HTTPUtil_getHostPort( PIHTTP *pPIHTTP )
  int HTTPUtil_phaseNameToNumber( char *pPhaseName )
  char *HTTPUtil_phaseNumberToName( int iPhaseNumber )
  char *HTTPUtil_protocolNumberToName( int iProtocol )
  int HTTPUtil_rFC822Time( struct tm *pT, Pi3String *pResult )
  int HTTPUtil_rcNameToNumber( char *pName )
  char *HTTPUtil_rcNumberToName( int iRC )
  int HTTPUtil_readTime( char *pLine, struct tm *pT )
  int HTTPUtil_recvFile( PIHTTP *pPIHTTP, PIIOBuffer *pBuffer, PIFInfo *pFInfo )
  int HTTPUtil_recvMultipartMsg( PIHTTP *pPIHTTP, PIIOBuffer *pBuffer, PFN_MUTLIPARTCB cb, void *pUser )
  int HTTPUtil_regexMatch( char *pRegex, int iRegex,
		char *pString, int iStringLen )
  int HTTPUtil_regexMatchPi3String( const Pi3String *pRegexPattern,
		const Pi3String *pString )
  int HTTPUtil_sendFile( PIIOBuffer *pBuffer, PIFInfo *pFInfo,
		int iBufferingFlags, int iSendFlags )
  void HTTPUtil_urlDecode( const Pi3String *pToDecode,
		Pi3String *pResult )
  void HTTPUtil_urlEncode( const Pi3String *pToEncode,
		Pi3String *pResult )
  const PIDLL *PIClass_getLibrary( const PIClass *pClass )
  const PIClass *PIClass_load( PIDB *pDB, PIConfig *pConfig,
	char *pName )
  const PIClass *PIClass_lookup( PIDB *pDB, char *pName )
  const PIClass *PIClass_lookupOrLoad( PIDB *pDB, 
	PIConfig *pConfig, char *pClassName )
  char *PIConfigString_getString( PIConfigString *pString )
  PIConfig *PIConfig_findConfiguration( PIDB *pDB )
  int PIConfig_loadConfigurationFile( PIDB *pDB,
	char *pFileName, PIConfig **ppConfigDB )
  PIConfig *PIConfig_lookupTree( PIConfig *pConfig,
	char *pKey, char *pInfoBuffer, int iLen )
  char *PIConfig_lookupValue( PIConfig *pConfig,
	char *pKey, char *pInfoBuffer, int iLen )
  PIDB *PIDBEx_new( PIDB *pParent, char *pName,
		void *fnLookup )
  int PIDBIterator_atValidElement( PIDBIterator *pIter )
  void *PIDBIterator_current( PIDBIterator *pIter,
	int iType, char *pKey )
  int PIDBIterator_delete( PIDBIterator *pIter )
  int PIDBIterator_next( PIDBIterator *pIter )
  int PIDBIterator_removeCurrent( PIDBIterator *pIter )
  int PIDB_add( PIDB *pTree, int iType, char *pKey, void *pV,
		int iFlags )
  int PIDB_delete( PIDB *pTree )
  char *PIDB_getFastKey( char *pKey, int iType )
  PIDBIterator *PIDB_getIterator( PIDB *pTree, int iType,
	char *pKey, int iFlags )
  PIDB *PIDB_getParent( PIDB *pThis )
  PIDB *PIDB_getRoot( PIDB *pTree )
  void *PIDB_lookup( PIDB *pTree, int iType, char *pKey,
	int iFlags )
  PIDB *PIDB_new( PIDB *pParent, char *pName )
  int PIDB_pidbflagsNameToNumber( char *pFlags )
  int PIDB_pidbtypeNameToNumber( char *pType )
  int PIDB_replace( PIDB *pTree, int iType, char *pKey,
		void *pV, int iFlags )
  int PIDLL_delete( PIDLL *pDLL )
  void *PIDLL_getAddress( PIDLL *pDLL, char *pSymbolName )
  char *PIDLL_getErrorDescription( const PIDLL *pDLL )
  void *PIDLL_getSystemHandle( const PIDLL *pDLL )
  int PIDLL_isLoaded( const PIDLL *pDLL )
  PIDLL *PIDLL_new( char *pPath )
  int PIFInfo_delete( PIFInfo *pFileInfo )
  int PIFInfo_exists( PIFInfo *pFileInfo )
  char *PIFInfo_getAlternateName( PIFInfo *pFileInfo )
  char *PIFInfo_getExtension( PIFInfo *pFileInfo )
  PIFInfo *PIFInfo_getFirstFileInDirectory( PIFInfo *pFileInfo )
  int PIFInfo_getLastModified( PIFInfo *pFileInfo )
  char *PIFInfo_getName( PIFInfo *pFileInfo )
  int PIFInfo_getNextFileInDirectory( PIFInfo *pFileInfo )
  char *PIFInfo_getPath( PIFInfo *pFileInfo )
  char *PIFInfo_getPathRoot( PIFInfo *pFileInfo )
  unsigned long PIFInfo_getSize( PIFInfo *pFileInfo )
  int PIFInfo_isDirectory( PIFInfo *pFileInfo )
  int PIFInfo_isExecutable( PIFInfo *pFileInfo )
  int PIFInfo_isLink( PIFInfo *pFileInfo )
  int PIFInfo_isReadable( PIFInfo *pFileInfo )
  int PIFInfo_isRegular( PIFInfo *pFileInfo )
  int PIFInfo_isWritable( PIFInfo *pFileInfo )
  PIFInfo *PIFInfo_new( char *pPath )
  int PIFMap_delete( PIFMap *pMappedFile )
  void *PIFMap_lock( PIFMap *pMappedFile, int *piLength )
  PIFMap *PIFMap_new( const PIFInfo *pFileInfo )
  int PIFMap_unlock( PIFMap *pMappedFile )
  int PIFile_close( int tFD )
  int PIFile_open( char *pPath, char *pFlags )
  int PIFile_read( int tFD, int iLength, void *pData )
  int PIFile_unlink( char *pPath )
  int PIFile_write( int tFD, int iLength, const 
	void *pData )
  int PIFile_writeAtomic( int tFD, int iLength, const 
	void *pData )
  void *PIHTTP_allocMem( PIHTTP *pPIHTTP, unsigned int iSize )
  int PIHTTP_delete( PIHTTP *pPIHTTP )
  PIDB *PIHTTP_getDB( PIHTTP *pPIHTTP, int iType )
  int PIHTTP_isChild( PIHTTP *pPIHTTP )
  PIHTTP *PIHTTP_new( PIObject *pIOObject, PIDB *pHostDB )
  PIHTTP *PIHTTP_newChild( PIHTTP *pParent )
  int PIIOBuffer_advanceBufferPointer( PIIOBuffer *pIOBuf,
	int iCount )
  int PIIOBuffer_delete( PIIOBuffer *pPIIOBuffer )
  int PIIOBuffer_flush( PIIOBuffer *pIOBuf )
  int PIIOBuffer_getBufferLen( PIIOBuffer *pIOBuf )
  int PIIOBuffer_getBytesSent( PIIOBuffer *pIOBuf )
  int PIIOBuffer_getLine( PIIOBuffer *pIOBuf, char *pszBuf,
	int iBufLen )
  int PIIOBuffer_getOutputBuffer( PIIOBuffer *pIOBuf,
	char **ppBuffer )
  void *PIIOBuffer_getUserData( PIIOBuffer *pIOBuf )
  PIIOBuffer *PIIOBuffer_new( PIObject *pIOObject )
  int PIIOBuffer_pollBeforeRead( PIIOBuffer *pIOBuf )
  char *PIIOBuffer_read( PIIOBuffer *pIOBuf, int *piRead )
  int PIIOBuffer_readToBuffer( PIIOBuffer *pIOBuf, char *pszBuf,
	int iMaxLen )
  void PIIOBuffer_resetBytesSent( PIIOBuffer *pIOBuf )
  void PIIOBuffer_setUserData( PIIOBuffer *pIOBuf, void *pUserData )
  int PIIOBuffer_write( PIIOBuffer *pIOBuf, char *pszBuf,
	int iLen, int iFlags )
  int PIIOBuffer_writeLn( PIIOBuffer *pIOBuf, char *pszBuf,
	int iLen, int iFlags )
  int PIIO_in( PIObject *pObj, void *pData, int iLen,
	int *piReceived, int iArgc, char **ppArgv )
  int 	PIIO_out( PIObject *pObj, void *pData, int iLen,
	int *piSent, int iArgc, char **ppArgv )
  const PILibrary *PILibrary_load( PIDB *pDB, PIConfig *pConfig,
	char *pLibraryName )
  const PILibrary *PILibrary_lookup( PIDB *pDB,
	char *pLibrary )
  const PILibrary *PILibrary_lookupOrLoad( PIDB *pDB, 
	PIConfig *pConfig, char *pLibraryName )
  int PILog_addMessage( PIDB *pDB, PIConfig *pConfig, int iType,
	char *pFormat, ... )
  int PILog_newSink( int iType, char *pParam )
  int PILog_writeDiagnostics( PIDB *pDB, int iFlags, 
	char *pFileName )
  int 	PILogic_execute( PIObject *pObj, int iArgc,
	char **ppArgv )
  PIObject *PIObject_copy( const PIObject *pObject,
	int iArgc, char **ppArgv )
  int PIObject_delete( PIObject *pObj, int iArgc,
	char **ppArgv )
  const PIClass *PIObject_getClass( const PIObject *pObj )
  PIConfig *PIObject_getConfigurationDB( const PIObject *pObj )
  PIDB *PIObject_getDB( const PIObject *pObj )
  char *PIObject_getName( const PIObject *pObj )
  void *PIObject_getUserData( const PIObject *pObj )
  PIObject *PIObject_load( PIDB *pDB, PIConfig *pConfig,
	char *pName, int iArgc, char **ppArgv )
  PIObject *PIObject_loadEx( const PIObject *pParent,
	char *pObjectKey )
  PIObject *PIObject_loadFromLine( PIDB *pDB, PIConfig *pConfig,
	char *pObjectLine )
  PIObject *PIObject_new( const PIClass *pClass, PIDB *pDB,
	PIConfig *pConfig, char *pName, int iArgc, char **ppArgv )
  int PIObject_readParameters(
	PIObject *pParent,
	int iArgc,
	char **ppArgv,
	int *fnParameters,
	void *pParam
	)
  int PIObject_setConfigurationDB( PIObject *pObj,
	PIConfig *pConfig )
  int PIObject_setDB( PIObject *pObj, PIDB *pDB )
  int PIObject_setUserData( PIObject *pObj, void *pData )
  int PIPlatform_advisaryLockFd( int tFD )
  int PIPlatform_advisaryUnlockFd( int tFD )
  int PIPlatform_afterUnsafeBlock()
  PISync *PIPlatform_allocLocalMutex()
  PISync *PIPlatform_allocLocalSemaphore( int iInitialCount,
	int iMaxCount )
  int PIPlatform_beforeUnsafeBlock()
  void PIPlatform_catchExceptions(
	void (*)(void *), void * )
  int PIPlatform_enter( char *pArgv0, int iVersion,
	PIPlatformFn fn )
  int PIPlatform_getCurrentDirectory( char *pBuffer, int iMaxLen )
  char *PIPlatform_getDescription()
  char PIPlatform_getDirectorySeparator()
  int PIPlatform_getLastError()
  int PIPlatform_getProcess()
  int PIPlatform_getProcessId()
  int PIPlatform_getUniqueId(char *szBuf, unsigned int iLen)
  int PIPlatform_pollFD( int fd, int iFlags,
	int iTimeout )
  int PIPlatform_pollNetFD( int fdSocket, int iFlags,
	int iTimeout )
  int PIPlatform_pollPipeFD( int fd, int iFlags,
	int iTimeout )
  void PIPlatform_setLastError( int iErrorCode )
  int PIPlatform_sleep( int iMilliseconds )
  int PIPlatform_waitForProcess( int tProcess, int iFlags,
	int iTimeout )
  int PIProgram_dbgDump( PIDB *pDB, char *pDumpFile )
  int PIProgram_enter( char *pProgramName, int iVersion,
	PIProgramFn fn )
  int PISync_delete( PISync *pSync )
  int PISync_lock( PISync *pSync )
  int PISync_tryLock( PISync *pSync )
  int PISync_unlock( PISync *pSync )
  int PIThread_begin( PIThread *pThread, PIThreadFn fnEntry,
    unsigned long ulData, int iPriority, int iFlags )
  void PIThread_dbgDump( char *pDbgDump )
  int PIThread_delete( PIThread *pThread )
  int PIThread_destroyThreadKey( int iKey )
  PIThread *PIThread_getCurrent()
  void *PIThread_getData( PIThread *pThread, int iKey )
  PIThread *PIThread_getMain()
  int PIThread_getPriority( PIThread *pThread, int *piPriority )
  void *PIThread_getSystemHandle( PIThread *pThread )
  int PIThread_initThreadKey()
  PIThread *PIThread_new( PIMemoryPool *pPool, int iStackSize )
  int PIThread_resume( PIThread *pThread )
  int PIThread_setData( PIThread *pThread, int iKey, void *pData )
  int PIThread_setPriority( PIThread *pThread, int iNewPriority )
  int PIThread_suspend( PIThread *pThread )
  int PIThread_terminate( PIThread *pThread,
	unsigned long ulExitCode )
  int PIThread_userYield()
  int PIThread_waitForThread( PIThread *pThread )
  int PIThread_yield()
  int PITimer_delete( PITimer *pTimer )
  int PITimer_elapsed( PITimer *pTimer, long *plSeconds,
		long *plMicroSeconds )
  PITimer *PITimer_new()
  int PITimer_reset( PITimer *pTimer )
  void *PIUserType_getValue( PIUserType *pUserType )
  void PIUtil_free( void *pV )
  void *PIUtil_malloc( unsigned long ulData )
  char *PIUtil_strdup( char *pS )
  int PIUtil_stricmp( char *pS1, char *pS2 )
  int PIUtil_strncmpi( char *pS1, char *pS2, int iLen )
  int Pi3Expression_delete( Pi3Expression *pExpr )
  Pi3Expression *Pi3Expression_new( char *pExpression,
	FnPi3Write *pParameters, Pi3String *pErrorDescription )
  int Pi3Expression_write( Pi3Expression *pExpression,
	PIHTTP *pPIHTTP, void *pData, char *pBuffer, int iBufferLength )
  int Pi3String_delete( Pi3String *pString )
  int Pi3String_getLength( const Pi3String *pString )
  char *Pi3String_getPtr( const Pi3String *pString )
  Pi3String *Pi3String_new( char *pString )
  Pi3String *Pi3String_newEx( char *pString, int iLength )


=head1 AUTHOR

A. U. Thor, E<lt>a.u.thor@a.galaxy.far.far.awayE<gt>

=head1 SEE ALSO

L<perl>.

=cut
